package com.steerinfo.baseinfo.meterbasetermtarecar.controller;

import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.baseinfo.meterbasetermtarecar.model.MeterBaseTermTareCar;
import com.steerinfo.baseinfo.meterbasetermtarecar.service.IMeterBaseTermTareCarService;
import com.steerinfo.meterwork.except.MarkerMetException;
import com.steerinfo.pretrack.pretrackscale.model.PreTrackScale;
import com.steerinfo.util.StringUtils;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.transaction.interceptor.TransactionAspectSupport;
import org.springframework.web.bind.annotation.*;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;

/**
 * MeterBaseTermTareCar RESTful接口：
 *
 * @author generator
 * @version 1.0-SNAPSHORT 2020-06-20 10:43
 * 类描述
 * 修订历史：
 * 日期：2020-06-20
 * 作者：generator
 * 参考：
 * 描述：MeterBaseTermTareCar RESTful接口
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 * @see null
 */
@RestController
@RequestMapping("/${api.version}/meterbasetermtarecars")
@Api(value = "/${api.version}/meterbasetermtarecars", tags = "期限皮重车辆配置 - MeterBaseTermTareCarController")
public class MeterBaseTermTareCarController extends BaseRESTfulController {

    @Autowired
    IMeterBaseTermTareCarService meterBaseTermTareCarService;

    @ApiOperation(value = "获取列表", notes = "分页查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbasetermtarecar:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        try {
            PageList<MeterBaseTermTareCar> list = meterBaseTermTareCarService.queryForPage(parmas, pageNum, pageSize);
            return success(list);
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "获取列表", notes = "分页模糊查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbasetermtarecar:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        try {
            PageList<MeterBaseTermTareCar> list = meterBaseTermTareCarService.queryLikeForPage(parmas, pageNum, pageSize);
            return success(list);
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "创建", notes = "根据MeterBaseTermTareCar对象创建")
    @ApiImplicitParam(name = "meterBaseTermTareCar", value = "详细实体meterBaseTermTareCar", required = true, dataType = "MeterBaseTermTareCar")
    //@RequiresPermissions("meterbasetermtarecar:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@RequestBody MeterBaseTermTareCar model) {
        try {
            String msg = meterBaseTermTareCarService.checkandadd(model);
            if (StringUtils.isNotEmpty(msg)) {
                return failed(null, msg);
            }
        } catch (Exception e) {
            e.printStackTrace();
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return failed(null, "操作异常，请确认！");
        }

        return success();
    }

    @ApiOperation(value = "获取详细信息", notes = "根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbasetermtarecar:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id) {
        try {
            MeterBaseTermTareCar meterBaseTermTareCar = meterBaseTermTareCarService.getById(id);
            return success(meterBaseTermTareCar);
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "更新详细信息", notes = "根据url的id来指定更新对象，并根据传过来的meterBaseTermTareCar信息来更新详细信息")
    @ApiImplicitParams({
            @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
            @ApiImplicitParam(name = "meterBaseTermTareCar", value = "详细实体meterBaseTermTareCar", required = true, dataType = "MeterBaseTermTareCar")
    })
    //@RequiresPermissions("meterbasetermtarecar:update")
    @PutMapping(value = "/{id}", produces = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody MeterBaseTermTareCar model) {
        try {
            String msg = meterBaseTermTareCarService.checkandupdate(id, model);
            if (StringUtils.isNotEmpty(msg)) {
                return failed(null, msg);
            }
        } catch (Exception e) {
            e.printStackTrace();
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return failed(null, "操作异常，请确认！");
        }

        return success();
    }

    @ApiOperation(value = "删除", notes = "根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbasetermtarecar:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id) {
        try {
            List<String> list = Arrays.asList(id.split(","));
            if (ListUtils.isNotEmpty(list)) {
                List<String> ids = ListUtils.convertList(list);
                meterBaseTermTareCarService.delete(ids);
            }
            return success();
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "服役", notes = "根据传过来的meterBaseTermTareCar集合信息来更新详细信息")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "meterBaseTermTareCar", value = "详细实体meterBaseTermTareCar", required = true, dataType = "meterBaseTermTareCar")
    })
    @Transactional
    @PostMapping(value = "/Recovery")
    public RESTfulResult Recovery(@RequestBody List<MeterBaseTermTareCar> models) {
        try {
            String msg = meterBaseTermTareCarService.Recovery(models);
            if (StringUtils.isNotEmpty(msg)) {
                return failed(null, msg);
            }
        } catch (Exception e) {
            e.printStackTrace();
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return failed(null, "操作异常，请确认！");
        }
        return success();
    }

    @ApiOperation(value = "停役", notes = "根据传过来的meterBaseTermTareCar集合信息来更新详细信息")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "meterBaseTermTareCar", value = "详细实体meterBaseTermTareCar", required = true, dataType = "meterBaseTermTareCar")
    })
    @Transactional
    @PostMapping(value = "/abolish")
    public RESTfulResult abolish(@RequestBody List<MeterBaseTermTareCar> models) {
        try {
            String msg = meterBaseTermTareCarService.abolish(models);
            if (StringUtils.isNotEmpty(msg)) {
                return failed(null, msg);
            }
        } catch (Exception e) {
            e.printStackTrace();
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return failed(null, "操作异常，请确认！");
        }
        return success();
    }

    @ApiOperation(value = "导入", notes = "根据MeterBaseTermTareCar对象创建")
    @ApiImplicitParam(name = "meterBaseTermTareCar", value = "详细实体meterBaseTermTareCar", required = true, dataType = "MeterBaseTermTareCar")
    //@RequiresPermissions("meterbasetermtarecar:create")
    @PostMapping(value = "/list")
    public RESTfulResult addlist(@RequestBody List<MeterBaseTermTareCar> models) {
        try {
            String msg = meterBaseTermTareCarService.checkandaddlist(models);
            if (StringUtils.isNotEmpty(msg)) {
                return failed(null, msg);
            }
        } catch (Exception e) {
            e.printStackTrace();
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return failed(null, "操作异常，请确认！");
        }
        return success();
    }

    @ApiOperation(value = "是否可留皮验证", notes = "是否可留皮验证")
    @ApiImplicitParam(name = "meterBaseTermTareCar", value = "详细实体meterBaseTermTareCar", required = true, dataType = "MeterBaseTermTareCar")
    //@RequiresPermissions("meterbasetermtarecar:create")
    @PostMapping(value = "/doValidTareWf")
    public RESTfulResult doValidTareWf(@RequestBody PreTrackScale model) {
        try {
            List<MeterBaseTermTareCar> list=meterBaseTermTareCarService.doValidTareWf(model);
            return success(list);
        } catch (Exception e) {
            e.printStackTrace();
            return failed(null, e.getMessage());
        }
    }
}
